package pps.core.system.mapper;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import pps.core.system.entity.SysOrganizationView;

import java.util.Date;
import java.util.List;

@Repository(value = "pps.core.system.mapper.SysOrganizationViewMapper")
public interface SysOrganizationViewMapper {

    SysOrganizationView selectOne(SysOrganizationView record);

    List<SysOrganizationView> selectList(SysOrganizationView record);

    List<SysOrganizationView> selectEffective();

    List<SysOrganizationView> selectSysOrganizationList(SysOrganizationView record);


    List<SysOrganizationView> selectOrganizationEffective(SysOrganizationView record);

    List<SysOrganizationView> selectOrganizationEffectiveByOuName(SysOrganizationView record);

    List<SysOrganizationView> selectOrganizationByParentOuIdOrOuId(SysOrganizationView record);

    List<SysOrganizationView> selectOrganizationByParentOuId(SysOrganizationView record);

    List<SysOrganizationView> selectAllListByOuId(SysOrganizationView record);

    List<SysOrganizationView> selectListByOuIds(@Param("list") List<String> list);

    List<SysOrganizationView> selectCountByParentOuIds(@Param("list") List<String> list, @Param("endTime") Date endTime);

    SysOrganizationView getSysOrganizationByOuLevelAndUserId(SysOrganizationView view);

    List<SysOrganizationView> getSysOrganizationListByOuLevelAndUserId(SysOrganizationView view);

    List<SysOrganizationView> selectOuAllByUserId(SysOrganizationView view);

    List<SysOrganizationView> selectOuSonByParentOuId(SysOrganizationView record);

    List<SysOrganizationView> selectOuSonByOuId(SysOrganizationView record);

    List<SysOrganizationView> selectOuTreeByOuName(SysOrganizationView record);

    SysOrganizationView getSysOrganizationByOuLevelAndOuId(SysOrganizationView view);

    List<SysOrganizationView> selectOrganizationBySubOuIds(@Param("list") List<String> list);

    List<SysOrganizationView> selectOuByOuId(SysOrganizationView record);

    List<SysOrganizationView> selectOuByOuIdsAndOuName(SysOrganizationView record);

    /**
     * 动态查询组织列表
     *
     * @param record 记录
     * @return {@link List}<{@link SysOrganizationView}>
     */
    List<SysOrganizationView> selectOrgListDynamicQuery(SysOrganizationView record);

    /**
     * 查询登录人组织下线路列表
     *
     * @param record 记录
     * @return {@link List}<{@link SysOrganizationView}>
     */
    List<SysOrganizationView> selectLineList(SysOrganizationView record);

    /**
     * 查询组织和线路列表
     *
     * @param record 记录
     * @return {@link List}<{@link SysOrganizationView}>
     */
    List<SysOrganizationView> selectOrgAndLineList(SysOrganizationView record);
}
