package pps.cloud.base.service;


import pps.cloud.base.service.data.base_power_line.DynamicQueryBasePowerLineInput;
import pps.cloud.base.service.data.base_power_line.DynamicQueryBasePowerLineOutput;
import pps.cloud.base.service.data.base_power_line.GetBasePowerLineInput;
import pps.cloud.base.service.data.base_power_line.GetBasePowerLineViewOutput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XListResult;
import xstartup.data.XSingleResult;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;

/**
 * 输电线路配置
 *
 * @author ZWT
 * @date 2023/09/05 15:34
 */
@XService
@XText("输电线路配置模块")
public interface BasePowerLineCloudService {

    /**
     * 输电线路配置模块--通过ID查询线路基本信息
     *
     * @param context 上下文
     * @param input   输入
     * @return {@link XSingleResult}<{@link GetBasePowerLineViewOutput}>
     */
    @XText("输电线路配置模块--通过ID查询线路基本信息")
    @XApiGet
    XSingleResult<GetBasePowerLineViewOutput> getBasePowerLineById(XContext context, GetBasePowerLineInput input);

    /**
     * 输电线路配置模块--条件查询线路基本信息列表
     *
     * @param context 上下文
     * @param input   输入
     * @return {@link XListResult}<{@link DynamicQueryBasePowerLineOutput}>
     */
    @XText("输电线路配置模块--条件查询线路基本信息列表")
    @XApiPost
    XListResult<DynamicQueryBasePowerLineOutput> getBasePowerLineList(XContext context, DynamicQueryBasePowerLineInput input);
}
