package pps.core.prediction.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.base.service.BasePowerLineCloudService;
import pps.cloud.base.service.BaseWatherCloudService;
import pps.cloud.base.service.data.CrawlBaseWatherInput;
import pps.cloud.base.service.data.GetBasePowerLineInput;
import pps.cloud.base.service.data.GetBasePowerLineViewOutput;
import pps.core.prediction.entity.BaseDataEnt;
import pps.core.prediction.entity.BaseDataView;
import pps.core.prediction.mapper.BaseDataMapper;
import pps.core.prediction.mapper.BaseDataViewMapper;
import pps.core.prediction.service.data.base_data.GetBaseDataInput;
import pps.core.prediction.service.data.base_data.GetBaseDataOutput;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.*;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;


@XService
public class PredictionService {
    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBaseDataOutput> getBaseData(XContext context, GetBaseDataInput input){
        BaseDataMapper mapper = context.getBean(BaseDataMapper.class);
        QueryWrapper<BaseDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseDataEnt::getId, input.getId());
        BaseDataEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseDataOutput output = new GetBaseDataOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBaseDataOutput> getBaseDataView(XContext context, GetBaseDataInput input){
        BaseDataViewMapper mapper = context.getBean(BaseDataViewMapper.class);
        BaseDataView view = XCopyUtils.copyNewObject(input , BaseDataView.class);
        BaseDataView entity = mapper.selectOne(view);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseDataOutput output = new GetBaseDataOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }
}
